<template>
  <div class="">
    <div class="flex items-center">
      <SearchSettings @search="search" hint="Поиск производится по названию статуса" style="width:calc(100% - 200px)" />
      <q-btn @click="addStatus" color="green" label="Добавить" icon-right="add" dense class="h-10 ml-4"/>
    </div>
    <q-spinner-gears
        v-if="!status.length"
        color="primary"
        size="8em"
        class="mx-auto mt-12"
    />

    <q-list v-if="1===2">
      <div v-for="(item, index) in status" :key="item._id">
        <q-expansion-item expand-separator dense class="w-full">
          <template v-slot:header>
            <p class="text-xl rounded px-2 my-4 text-white" :style="{backgroundColor: item.color}">{{item.name}}</p>
          </template>
          <q-card>
            <q-card-section>
              <div class="flex">
                <q-input @change="updateStatus(item)"
                         v-model="item.name"
                         dense
                         autofocus
                         counter
                         hint="Редактирование названия статуса"
                         style="width: calc(100% - 150px)"
                />

                <q-btn @click="deleteStatus(item._id, index)" label="Удалить" color="red" class="h-10 ml-4" />
              </div>
              <q-color
                  v-model="item.color"
                  @change="updateStatus(item)"
                  no-header
                  no-footer
                  default-view="palette"
                  class="my-picker w-20"
              />
            </q-card-section>
          </q-card>
        </q-expansion-item>
      </div>
    </q-list>
    <q-list>
      <div class="flex">
        <q-chip v-for="(item, index) in status" :key="item._id" :label="item.name" :style="{backgroundColor: item.color}" class="text-white py-2">
          <q-popup-edit v-model="item.name" v-slot="scope" >
            <q-input v-model="scope.value" dense autofocus counter />
            <q-btn
                v-close-popup
                class="float-right"
                label="Сохранить"
                color="green"
                size="sm"
                @click="updateStatus(item, index, scope.value, 'name')"
            />
          </q-popup-edit>
          <q-icon name="palette" size="sm" class="ml-2 cursor-pointer">
            <q-popup-edit v-model="item.color" v-slot="scope" >
              <q-color
                  v-model="scope.value"
                  @change="updateStatus(item, index, scope.value, 'color')"
                  no-header
                  no-footer
                  default-view="palette"
                  class="my-picker w-20"
              />
            </q-popup-edit>
          </q-icon>
          <q-icon name="delete" size="sm" class="ml-1 cursor-pointer" @click.stop="deleteStatus(item._id, index)"/>
        </q-chip>
      </div>
    </q-list>
  </div>
</template>

<script>
import api from "../../API/api";
import {ref} from "vue";
import SearchSettings from "./Search-settings.vue";
import Modal from "../../components/Modal.vue";
import {useDebounce} from "../../components/useDebounce";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: "Status-settings",
  components: {Modal, SearchSettings},
  setup () {
    const status = ref([])

    api.getStatusLeads()
      .then(r => {
        status.value = r.data.statusLeads
        stringOptions = r.data.statusLeads
      })
    function search (value) {
      const needle = value.toLocaleString().toLocaleLowerCase()
      status.value = stringOptions.filter(v => v.name.toLocaleLowerCase().indexOf(needle) > -1)
    }
    async function addStatus () {
      const newStatus = {name: 'Новый статус', color: '#5b5b5b'}
      await api.addStatusLead(newStatus)
        .then(r => {
          newStatus._id = r.data._id
          status.value.unshift(newStatus)
        })
    }
    async function updateStatus (item, index, value, key) {
      key === 'name' && (status.value[index].name = value) || (status.value[index].color = value)
      await useDebounce(api.changeStatusLead({
        statusId: item._id,
        name: key === 'name' && value || item.name,
        color: key === 'name' && value || item.color
      }), 300)
    }
    async function deleteStatus (statusId, index) {
      await api.deleteStatusLead({statusId})
        .then(() => status.value.splice(index, 1))
    }
    return {
      status,
      search,
      addStatus,
      updateStatus,
      deleteStatus
    }
  }
}
</script>

<style scoped>

</style>